CLS
@ECHO OFF
IF NOT %6%%Z == %%Z GOTO OPS
IF NOT %2%%Z == %%Z IF EXIST %1 GOTO START
IF NOT %1%%Z == %%Z IF NOT EXIST %1 GOTO END

ECHO.
ECHO.           KEYWORD FULL TEXT SEARCH PROGRAM
ECHO.
ECHO.    KEYWORD AND KEYWENG COPYRIGHT (C) 1995 CHUCK BERNT 
ECHO.                   ALL RIGHTS RESERVED
ECHO.  
echo. This batch program locates lines in files based on the 
echo. keywords found in those lines.  There is an implied
echo. wild card before and after each keyword specified.
echo. Specifying JOE could produce a line containing VANJOETOWN.
echo. Wild cards can be used in specifying the search files so
echo. that whole directories can be searched at a time.
echo. Up to two positive and up to two negative keywords can be
echo. specified.  All lines meeting the specification will be placed
echo. in TXTFOUND.TXT.  If specified, both positive keywords
echo. will be present in EVERY found line.  No found line will
echo. contain a negative keyword.  The search is not case
echo. sensitive.  To specify more keywords after running the search
echo. program, rename the output file and use that file as the input
echo. file for another search using the new keywords.
echo.
echo.    The syntax (and translation) is as follows.
echo.  
PAUSE
CLS
ECHO.
ECHO.
ECHO.
ECHO. SYNTAX: KEYWORD FILENAME.EXT KEYWORD1
ECHO.         (Find in FILENAME.EXT all lines
ECHO.         containing KEYWORD1)
echo.
ECHO.                           OR
echo.
ECHO. SYNTAX: KEYWORD FILENAME.EXT KEYWORD1 KEYWORD2
ECHO.         (Find in FILENAME.EXT all lines
ECHO.         containing both KEYWORD1 and KEYWORD2)
echo.
ECHO.                           OR
echo.
ECHO. SYNTAX: KEYWORD FILENAME.EXT KEYWORD1 KEYWORD2 KEYWORD3
ECHO.         (Find in FILENAME.EXT all lines containing
ECHO.         both KEYWORD1 and KEYWORD2 but not KEYWORD3)
echo.
ECHO.                           OR
echo.
ECHO. SYNTAX: KEYWORD FILENAME.EXT KEYWORD1 KEYWORD2 KEYWORD3 KEYWORD4
ECHO.         (Find in FILENAME.EXT all lines containing both
ECHO.         KEYWORD1 and KEYWORD2 but not KEYWORD3 or KEYWORD4)
ECHO.  
PAUSE
CLS
ECHO.
ECHO.
echo.  NOTES:
ECHO.
echo.   A. The filename above is given with an extension.  Wild
echo.      cards can be used to specify FILENAME.EXT.
ECHO.
echo.   B. Keywords may not contain SPACES, TABS or any of the
echo.      following characters; COMMA, PIPE, GREATER THAN or LESS
ECHO.      THAN SIGN or a SEMICOLON.
ECHO.
echo.   C. To specify KEYWORD3 KEYWORD2 must be specified.  KEYWORD2
echo.      can be set equal to KEYWORD1 to fulfill this requirement
ECHO.      and in effect specify only one positive keyword with one
echo.      or two negative keywords.  In this case KEYWORD2 is only
echo.      acting as a dummy place holder.
ECHO.
echo.   D. To suppress filename headers in the output file set the
echo.      environmental variable KEYHEAD=NO at the DOS prompt.
echo.      SYNTAX: SET KEYHEAD=NO
echo.      The program will not reset this variable.  To reset
echo       this variable, use the following syntax.
echo       SYNTAX: SET KEYHEAD=
echo.

echo.  
PAUSE
CLS

ECHO.
ECHO.
echo.   E. This batch program handles the slow activities like
echo.      the user interface and file specification expansion
echo.      while the KEYWENG command (key word engine command)
echo.      handles the high speed search activities.  This batch
echo.      program can be COPIED to another name and tailored to
echo.      to the user's specific preferences.  Also see
echo.      remarks contained in this batch file regarding the 
echo.      autostart of your editor at the conclusion of a 
echo.      keyword search.
ECHO.  
ECHO.
pause
cls
ECHO.
ECHO.WARNINGS:
echo.  1. The file TXTFOUND.TXT will be overwritten
echo.     without warning with the results of this search.
echo.
echo.  2. The temporary files TXFOUND1.TMP and TXFOUND2.TMP
echo.     are used and deleted at the conclusion of this program.
echo.
echo.  3. Do not attempt to autostart your system editor from
echo.     within TXTPRO since the memory requirements for most
echo.     editors are too high for TXTPRO.  It is acceptable to
echo.     autostart your editor if this batch program is COPIED to 
echo.     another name and used at the DOS prompt.
echo.
GOTO END

:OPS
ECHO.
ECHO.
ECHO.
ECHO.
ECHO. FIVE IS THE MAXIMUM NUMBER OF ARGUMENTS FOR THIS COMMAND.
ECHO. THE SYNTAX IS: 
ECHO. TEXT KEYW FILENAME.EXT KEYWORD1 KEYWORD2 KEYWORD3 KEYWORD4
ECHO.
ECHO  KEYWORD2, KEYWORD3 AND KEYWORD4 ARE OPTIONAL.   
ECHO. PLEASE TRY AGAIN.
ECHO.  
GOTO END

:START
del TXTFOUND.TXT
echo ************************************************************ > TXTFOUND.TXT
ECHO THIS RESULTS FILE IS TXTFOUND.TXT  >> TXTFOUND.TXT
ECHO WHICH IS LOCATED IN DIRECTORY >> TXTFOUND.TXT
cd >> TXTFOUND.TXT
ECHO FILE SPECIFICATION  %1 >> TXTFOUND.TXT
ECHO SEARCH PHRASE: "%2" AND "%3" BUT NOT "%4" OR "%5" >> TXTFOUND.TXT
echo ************************************************************ >> TXTFOUND.TXT
ECHO.
ECHO.     KEYWORD AND KEYWENG COPYRIGHT (C) 1995 CHUCK BERNT 
ECHO.                     ALL RIGHTS RESERVED
ECHO.
ECHO.
ECHO            TO ABORT TYPE CONROL+C OR CONROL+BREAK
ECHO.
ECHO          ALTHOUGH YOU WILL BE GIVEN A CHANCE TO CONTINUE,
ECHO          IT IS BETTER TO START OVER BECAUSE SOME OF 
ECHO          WHAT IS TYPED AT THE KEYBOARD WILL BE PLACED 
ECHO          IN THE TXTFOUND.TXT FILE.
ECHO.

for %%f in (%1) do KEYWENG %%f %2 %3 %4 %5
CLS

REM  **** If you have copied this batch file to another 
rem       FILENAME.COM for use as a separate DOS
rem       command, you can automatically start your system
rem       editor at the conclusion of the keyword program
rem       by removing the REM in the next line.  If your editor
rem       has a name different than edit you will also need to
rem       change it in the line below.  Do not attempt to start
rem       your editor from within TXTPRO since the 
rem       memory requirements for most editors are too high for
rem       TXTPRO.


REM edit TXTFOUND.TXT

DEL TXFOUND1.TMP
DEL TXFOUND2.TMP

:END

